import numpy as np

expected_columns = [('Cell Line: H1650',	'Category: two',	'Gender: Male'),
( 'Cell Line: H23',	'Category: two',	'Gender: Male'),
( 'Cell Line: CAL-12T',	'Category: two',	'Gender: Male'),
( 'Cell Line: H358',	'Category: one',	'Gender: Male'),
( 'Cell Line: H1975',	'Category: two',	'Gender: Female'),
( 'Cell Line: HCC15',	'Category: two',	'Gender: Male'),
( 'Cell Line: H1355',	'Category: three',	'Gender: Male'),
( 'Cell Line: HCC827',	'Category: one',	'Gender: Female'),
( 'Cell Line: H2405',	'Category: five',	'Gender: Male'),
( 'Cell Line: HCC78',	'Category: five',	'Gender: Male'),
( 'Cell Line: H1666',	'Category: four',	'Gender: Female'),
( 'Cell Line: H661',	'Category: five',	'Gender: Male'),
( 'Cell Line: H838',	'Category: five',	'Gender: Male'),
( 'Cell Line: H1703',	'Category: five',	'Gender: Male'),
( 'Cell Line: CALU-3',	'Category: four',	'Gender: Male'),
( 'Cell Line: H2342',	'Category: four',	'Gender: Female'),
( 'Cell Line: H2228',	'Category: one',	'Gender: Female'),
( 'Cell Line: H1299',	'Category: three',	'Gender: Male'),
( 'Cell Line: H1792',	'Category: three',	'Gender: Male'),
( 'Cell Line: H460',	'Category: three',	'Gender: Male'),
( 'Cell Line: H2106',	'Category: four',	'Gender: Male'),
( 'Cell Line: H441',	'Category: one',	'Gender: Male'),
( 'Cell Line: H1944',	'Category: three',	'Gender: Female'),
( 'Cell Line: H1437',	'Category: four',	'Gender: Male'),
( 'Cell Line: H1734',	'Category: one',	'Gender: Female'),
( 'Cell Line: LOU-NH91',	'Category: five',	'Gender: Female'),
( 'Cell Line: HCC44',	'Category: four',	'Gender: Female'),
( 'Cell Line: A549',	'Category: four',	'Gender: Male'),
( 'Cell Line: H1781',	'Category: one',	'Gender: Female')]

expected_rows = [('Gene: CDK4',	'Gene Type: Interesting'),
('Gene: LMTK3',	'Gene Type: Not Interesting'),
('Gene: LRRK2',	'Gene Type: Not Interesting'),
('Gene: UHMK1',	'Gene Type: Not Interesting'),
('Gene: EGFR',	'Gene Type: Interesting'),
('Gene: STK32A',	'Gene Type: Interesting'),
('Gene: NRK',	'Gene Type: Interesting'),
('Gene: ERBB2',	'Gene Type: Not Interesting'),
('Gene: ERBB4',	'Gene Type: Not Interesting'),
('Gene: AAK1',	'Gene Type: Not Interesting'),
('Gene: SRPK3',	'Gene Type: Not Interesting'),
('Gene: STK39',	'Gene Type: Interesting'),
('Gene: GRK4',	'Gene Type: Not Interesting'),
('Gene: TBK1',	'Gene Type: Not Interesting'),
('Gene: INSRR',	'Gene Type: Not Interesting'),
('Gene: IRAK1',	'Gene Type: Interesting'),
('Gene: KDR',	'Gene Type: Not Interesting'),
('Gene: NPR1',	'Gene Type: Interesting'),
('Gene: PAK3',	'Gene Type: Not Interesting'),
('Gene: PDGFRA',	'Gene Type: Interesting'),
('Gene: PDK4',	'Gene Type: Not Interesting'),
('Gene: ULK4',	'Gene Type: Interesting'),
('Gene: PRKCE',	'Gene Type: Not Interesting'),
('Gene: PRKG2',	'Gene Type: Not Interesting'),
('Gene: MAPK4',	'Gene Type: Interesting'),
('Gene: MAPK11',	'Gene Type: Interesting'),
('Gene: STK31',	'Gene Type: Interesting'),
('Gene: GRK1',	'Gene Type: Not Interesting'),
('Gene: ROS1',	'Gene Type: Interesting'),
('Gene: MAP2K4',	'Gene Type: Interesting'),
('Gene: SRC',	'Gene Type: Interesting'),
('Gene: TGFBR1',	'Gene Type: Interesting'),
('Gene: CAMK2B',	'Gene Type: Not Interesting'),
('Gene: STK24',	'Gene Type: Interesting'),
('Gene: DCLK3',	'Gene Type: Not Interesting'),
('Gene: LATS1',	'Gene Type: Not Interesting'),
('Gene: NEK9',	'Gene Type: Not Interesting'),
('Gene: MYLK3',	'Gene Type: Not Interesting')]

expected_content = np.array([[-0.792803571, 0.527687127, 0.000622536, 0.356722594, 0.933286088, -0.131728538, 0.808451944, 4.240884801, -0.540231391, -0.981456952, -0.84689892, -0.252795921, 0.114189581, -0.06649884, 0.149218809, 1.351263924, 0.645867212, 0.60561098, 3.232454573, 0.342634572, -0.430912324, -0.40590567, 0.199563989, -1.122536294, 2.210334571, 0.405126315, -0.089763159, 0.405126315, 0.340012773],
[0.17762054, -0.016061489, 5.422113833, 1.307039675, 0.355814985, 0.276904994, 0.483153915, -0.240495821, 1.336445996, 1.149618502, 0.361412978, -0.380518938, -0.213541004, -0.471938639, -0.620858723, -0.163637058, -0.487256142, -0.029569688, -0.232057778, -0.669036939, -0.449241698, 1.158930406, 0.511962022, 2.370834155, 0.262893885, -0.513128895, -0.501210068, 0.439277561, -0.342460508],
[-0.697876151, -0.555610265, -0.360497559, -0.460236731, -0.680760697, -0.169463518, 1.715708875, -0.517104823, 0.184987709, 0.8106597, -0.440334448, -0.621052026, -0.086803358, -0.753966225, -0.401972037, -0.562086752, -0.560644597, 0.542301381, -0.382639145, -0.377853523, -0.713472923, -0.377609368, 4.308904581, -0.638131949, -0.556114063, -0.318145763, -0.489582714, 1.677376527, -0.682790464],
[0.850546518, -0.263279907, 0.179253031, 0.398646721, 1.537663802, 0.505291411, 0.902366491, -0.16628803, 0.630730564, 0.399448283, 0.847171367, -0.442268094, 0.44368676, 1.552969029, 1.110283483, -0.326698072, -0.405267374, 0.663747183, 0.424470033, 0.283221899, -4.243973921, 0.718315578, 1.747343933, -1.020927175, 0.305028514, 1.47174613, 0.048902278, -0.255283556, 0.548224573],
[1.412416216, 0.018987506, 0.902251622, -0.17813747, 0.781819022, 0.211815895, -0.023427175, 3.557295952, 1.173783556, -0.012362164, 0.769782484, -0.681031743, -1.047375389, 0.652065499, 0.172316691, 2.072433469, 1.135709377, -0.169977181, 0.881067136, -0.486159025, -1.451838026, 0.371237737, -0.581665325, -0.126356157, 0.241004724, 1.06526919, 0.974531796, 0.668645091, 0.05696489],
[-0.388039665, -0.592626614, -0.24413651, 0.740364734, 3.023348415, -0.433985412, -0.630124457, 1.156531983, 0.433696213, 3.84950782, -0.225425742, -0.656106808, -0.311953357, -0.397450226, 1.044025538, -0.247816912, 3.640524345, -0.59251039, 0.514666245, -0.45396994, 1.649737631, 3.366020313, -0.430502237, -0.295312303, 2.824551497, -0.014275115, -0.410477794, -0.229717784, 3.709828616],
[1.408537135, -0.017369325, -0.367127962, 0.313253548, -0.16288686, 0.027411933, -0.281351556, 5.813846489, -0.161706584, 0.472386752, -0.33979584, 0.669956625, -0.2596391, -0.386601295, -0.293654593, 4.390499721, -0.420942214, -0.402955154, -0.346809494, -0.222725132, 0.36849943, 1.49303248, -0.34174718, -0.343420451, 5.284808607, -0.358156896, -0.222931558, -0.401391167, -0.412478715],
[0.906642406, -0.684771423, 0.015261254, 0.16056792, 0.365002113, -0.564392699, 0.169072827, -0.035192496, -0.031210405, 0.447742443, 0.544075103, 0.280008477, -0.066278222, -0.225814318, 4.103496507, 1.219691566, -0.245022001, -0.681552658, -0.304817333, -0.511212295, -1.100056017, 1.335983295, -0.500561544, 0.721259819, 0.284747072, 0.232812724, -0.796930101, -0.156381455, 1.503853721],
[-0.452907052, -0.392790536, -0.374173515, -0.527418493, -0.320103334, -0.560657219, -0.312847509, -0.463903623, -0.304652329, -0.30897114, -0.331935876, 4.098930821, -0.413942149, -0.501418917, 1.256164876, -0.12356019, -0.425577927, -0.36998588, -0.054684881, -0.484730631, -0.419739472, -0.432412432, 0.143245619, -0.266932489, -0.340860307, -0.231847291, -0.448292539, -0.42868169, -0.615936889],
[3.579051735, 0.92330807, -0.651094367, 0.952743833, -0.212733397, 0.006074527, -0.121038246, 0.083769063, -0.722678214, 1.669410989, -0.247600883, -0.284623649, -0.687716717, -0.320883885, -0.93370415, -0.309230053, 0.544870152, 0.824029397, -0.087291924, -0.973905867, -0.308282983, 0.822145704, -0.72904308, -0.088865731, -0.29848499, -0.451367112, -1.134040733, 0.379230443, 1.491612577],
[-0.582761335, -0.706379425, 0.364313301, -0.483011414, -0.71307719, -0.048548064, -0.527944549, 0.337501769, -0.656781635, -0.323318624, -0.432950623, -0.414799098, -1.02570516, -0.861415433, 0.113447131, -0.110117735, -0.493510825, 0.148841502, -0.341096914, -0.373760525, 5.16013802, -0.204906932, -0.465574863, -0.170405491, 0.046286803, -0.100887639, 0.936150906, -0.15980844, -0.846857677],
[-0.58688791, -0.186685902, -3.51852921, 0.250628834, -0.477773537, -0.62381107, -0.92202388, -0.55383453, 0.018847867, 1.267644557, 0.243732055, -0.233528273, 0.070726356, -0.256360198, 1.741001607, 0.168247379, -0.245974299, 0.014972759, -0.537623787, 0.259364957, 1.303190492, 1.043208024, -1.021094946, -0.097444212, -0.679290593, 0.132592576, -0.440607517, -0.21005684, 0.651311995],
[-0.693639785, -0.357559299, -0.903861262, -0.810450279, 0.293775461, 1.012469252, -0.1044623, -0.573757161, -0.629467998, -1.131138938, -0.401984075, -0.672554564, -1.182791974, -1.00138041, -1.020216093, -0.437799213, -0.103783602, -0.387565928, 0.386471772, -0.524742175, 3.627070248, -0.846550806, -0.473736661, 0.443388919, 0.766135257, 0.193683015, -0.614757268, -0.382906171, -0.864410411],
[0.327203594, 0.857319301, -1.397356596, -0.226683585, -0.986051455, 0.438343505, 0.095527129, 5.598772308, 0.535025797, -0.057479225, -0.089086932, -0.473291011, 2.070252907, 0.201409888, 1.134728133, 0.095734104, 0.22916067, 0.566649702, 1.011889663, 0.902342556, 0.735510304, -0.493538517, 3.176918602, 0.490045737, -0.693495689, -0.183704878, -0.182356844, 0.744728769, -0.311064392],
[0.331108191, -0.467978397, 0.681112329, -1.195914121, -0.538461957, 3.616542204, 0.094919881, 0.527357553, -0.160478312, -0.940444939, -1.025689676, 0.053722044, 0.081275611, -0.616337936, -0.48042057, 0.620903382, -0.723793064, -0.759642991, -0.744900744, -0.43363819, -0.804929849, 0.429022269, 0.765012989, 0.400356525, 0.207741849, 1.474373008, 0.888734282, 0.387715581, -0.623678298],
[0.141183837, 0.788608352, 0.51421388, 0.528255597, 0.906234597, 0.050158065, -0.843341382, 1.44384296, -0.253699343, 0.562537497, -0.505923659, -6.621630156, -1.253907087, 0.947883556, 0.394657662, 0.613122698, -0.223205762, 0.905373736, 0.679301554, 0.859789222, -0.022354553, 1.046726052, 0.194471, 0.359912834, -0.806348234, 1.586619876, 0.311985824, 0.544470027, 1.479598537],
[-0.524309949, -0.285994749, -0.484871681, 0.176655189, -0.139711627, -0.352978397, -0.192529854, -0.601257973, -0.427323427, 0.459403791, -0.383001, -0.571316753, -0.387982572, -0.353945118, -0.24031472, -0.305685522, 0.456864915, -0.134886653, 2.136583182, -0.463127859, -0.600408393, 4.430955918, -0.374772774, -0.206853106, 1.756104521, 0.832887289, -0.314392176, -0.31373742, 0.493420283],
[0.509592174, 0.464774315, 0.275495704, -0.01882253, -0.005537792, -0.457197866, 3.408253083, -0.430407643, -0.754186082, -0.836530855, -0.277053957, -0.54257843, 0.850439577, -0.298981449, -0.169394809, 0.254783369, -0.427821755, -0.1389465, 0.618069135, 1.926349897, -0.305399918, -0.535939215, -0.078661666, 6.267854465, -0.57293844, -0.302168609, 0.72307512, 0.611863003, -0.2145995],
[-0.554447111, -0.145753485, 0.019807701, -0.634915727, -0.493766887, -0.587644968, -0.223714996, 1.385049476, -0.346100755, 0.254536609, 0.057887318, -0.593081366, -0.47065185, -0.753944095, -0.044570503, -0.334597636, 0.339587788, -0.135201173, -0.111896921, 4.913848539, -0.542750046, -0.27783299, -0.689097582, -0.216688006, 1.127699857, 0.03588747, -0.070416156, -0.553268062, -0.977427689],
[-0.530831743, -0.260873607, -0.461134617, -0.389056188, -0.512555424, -0.513202268, -0.337550397, -0.449953768, -0.184845421, -0.565880657, -0.376356202, -0.285266104, -0.570505879, 3.598950655, -0.477052971, -0.364449691, -0.648917127, -0.390363086, 1.117877995, -0.464086586, -0.456431016, -0.571010056, -0.456668794, -0.58230495, -0.426192704, -0.411161613, -0.455618608, -0.297498019, -0.47141323],
[-0.643246331, 0.052021433, -0.735006626, 0.041068843, -0.062094125, 5.477714716, 1.256686967, -0.136401851, 0.577266871, -0.60002565, 0.087671916, -0.560959779, -0.56490393, -0.629261602, -0.214226487, 0.09929963, -0.095715004, -0.632856345, 1.09320354, 0.386976419, -0.374720076, -0.564957229, 1.680895489, 0.508498891, 0.916604247, -0.607497709, 0.58989289, -0.122764837, -0.533651064],
[-0.693868027, 0.57619653, -0.488541037, -0.60094858, 1.139598497, -0.024286993, -0.288194559, -0.499250839, 0.103697413, -1.044716157, -1.02427507, 3.023003444, 3.859028873, 0.742978442, -0.352722819, 0.069205383, -1.117741919, 0.651553716, -0.364768511, -0.5472691, -0.735728719, -0.623797671, -0.105370633, -0.139431549, -0.055372648, 0.774449831, 0.538987341, 0.35514519, -1.45386407],
[0.006531886, 0.564826732, 3.695318524, 0.316255033, -0.268737774, 0.936461505, 0.2291517, 0.649579007, -0.330103595, -0.504534505, 0.264729237, -0.977228043, 0.493632169, -0.401821398, -0.286231779, 0.143371278, -0.360231532, 0.340762717, 0.633162512, -0.710530502, -1.334690191, 0.158108045, -0.347820435, -0.074497061, -0.970507716, -0.26479443, -0.298648517, -0.10090872, -0.11742112],
[-0.185695405, -0.173758799, 0.084357105, 1.826502656, 0.00816719, -1.102148634, 0.299002536, 0.458848186, 0.292508806, 0.110508201, 0.083592283, -0.494333063, -0.117947546, -0.539712481, -0.106334279, -0.403083002, -0.789473381, 1.041787363, 1.70041072, -0.293951867, 4.839524758, 1.015480815, 0.841188534, -0.620389764, -0.565583764, -0.262366184, 0.226425315, -0.048000565, 1.126249373],
[0.184462349, -0.526037871, 0.432087272, -0.882311913, 0.246356093, 0.858754521, 0.052858019, -1.118340603, -0.846948816, -0.778824075, 3.525192777, -1.872745007, -0.779756435, -1.039639399, -0.59333431, 0.402156007, -1.387426464, -0.145435051, -0.46497243, -0.221064461, -0.861483648, 0.125415634, -0.191849116, 2.374460297, -0.74142144, 0.7654394, 1.029796862, 0.03307866, 0.44066582],
[1.760301448, -0.912259652, -1.163345889, -0.965891664, -0.795153414, -0.616300339, -1.360743997, -1.448291877, -0.024088935, -1.188868793, -0.229906845, 2.181489143, -1.154435684, 6.28292787, -0.303782002, -0.165568925, -1.126153349, 1.678721355, -1.683560793, -0.864063548, -0.025445472, 1.890946219, 0.667805988, -0.625764381, -1.063340313, 3.222816803, -0.001359619, -0.203661756, 0.187669924],
[-0.07364355, -0.103789279, -0.171304836, 0.351910065, 0.63677969, -0.136732984, 0.356830815, 3.889115824, 0.645442526, 1.366358918, 0.995319244, 5.608685402, 1.101919141, -0.554900568, 0.087820649, 0.061305127, 1.931275557, -0.692417574, -0.481807702, -0.16288735, -0.538298189, 2.440412245, 0.804274605, -0.605526195, 1.788457016, -0.376520922, 0.35819202, 0.164487781, 3.719306763],
[-0.751526741, 0.49762292, -0.142534658, -0.882124083, -1.151282849, 2.307907188, -0.12032085, -0.351269532, -1.526178564, -0.753268428, 3.600861739, -1.223995853, -0.607229424, -0.027417898, 0.190161632, 0.610550408, 0.149796331, -0.122879865, 0.247865963, -0.404833708, 0.736929754, -0.944275068, -0.078919294, 0.661648005, -0.244948779, 3.051534602, -0.107365228, 0.367536408, -1.517985824],
[-0.31236414, 0.701257089, 0.47520812, -0.585297054, -0.122694283, -0.866875137, 0.367939523, -0.481103706, 2.072237711, 10.29186436, 1.298805701, -0.628175917, -0.173084375, -0.02710755, 0.355169073, 0.470456905, 0.121400231, 0.374924602, -0.278307341, -0.553746266, -0.935156558, -0.042420296, -0.479479902, -0.332400886, -0.710017011, 1.873931755, 0.204554429, -0.32315246, 0.187572521],
[0.11931136, 0.593670684, 0.489152771, 0.841683345, 1.064673748, 0.095113499, 1.050152022, 1.891488427, -5.5283552, 0.64306832, -1.100026181, 0.765710935, 1.165406655, 0.30638633, -1.365894262, 0.635492291, -0.377798616, 0.521665309, -0.608497433, 0.398484128, -0.988354968, 1.36349214, 1.36269783, -0.112291585, -0.262719995, 0.503524059, 0.498006014, 1.525942005, 0.339189212],
[-0.294263824, -0.618071649, -0.252534114, -0.78660676, -0.228026664, 0.977860794, -1.200449832, -0.22037931, -0.240489906, -0.201675468, 1.47598938, -0.557000568, -0.502553204, -0.437501309, 0.966927023, 0.379670097, 0.048795579, 0.250622869, 2.961024714, 2.299033235, -1.210659274, 0.418655141, 1.161954005, -0.15700654, -1.254142937, -0.574558055, -0.662438275, 3.702617515, -0.35302723],
[-0.000863802, 0.735638383, -0.680289747, 0.040925843, 0.359330228, -1.587400295, -1.041686081, 0.071551408, -0.168322665, -1.377303308, 3.604539089, -0.004601068, 1.527568732, -0.300154707, -0.786135509, -0.138050924, -0.366480418, -0.796970206, -0.030155544, 0.803100056, 0.683145561, -0.900708154, 0.15251077, 0.140092011, 0.376815421, -1.214319621, 1.326197465, 1.523070279, -1.312001824],
[-0.276736819, -0.426080887, -0.160160461, -0.890032771, -0.437405434, 0.143897214, -0.573425958, -0.486419381, -0.536963482, -0.657041002, -0.473345418, -0.237475279, -0.669396538, -0.559435302, 0.038953301, 0.033709721, -0.343587801, -0.513218087, -0.592303313, -0.431221835, 5.339202897, -0.493778587, -0.645000361, -0.477984867, -0.401579746, -0.621782124, -0.249394627, -0.303365249, -0.922343302],
[-0.31807579, -0.814110809, 0.646545188, 0.26837169, -9.425120961, -1.073853473, -2.049589626, -0.346921024, 0.997283181, 0.300619253, -0.543103864, -1.150792172, -2.283061167, -0.162802216, -1.053859713, -1.377541743, -0.288349474, -0.922266884, -1.123953091, -0.762953893, -0.687357148, 0.28991073, 0.317576672, -0.345565515, 0.541683, 0.009754099, 0.73792006, -0.624271752, 0.100532547],
[-0.670177714, 3.224533501, 0.145509552, 0.107432319, -1.120492739, 0.288890539, 1.549545918, -0.342665051, -0.017402855, -0.420002244, -0.361387453, -1.264272075, -0.794507765, -0.619944678, -0.338767802, -0.148529478, -1.078879645, 0.130939014, -1.307815313, -1.818798474, 3.683694337, 0.920647357, -0.847056974, -0.343798498, -1.21552566, -0.853845334, -0.357215055, -0.043911541, -0.955847309],
[-0.695252888, 4.299877134, -0.175587126, -0.061022137, -0.391646018, 3.385451038, 0.345114288, -0.505734993, -0.482953864, -0.081815586, -0.928486879, 0.976209137, 0.099021487, 2.494690556, -1.088742779, 0.437174751, -0.507169467, 2.028724319, -0.507954247, 0.143506281, -1.19702953, 0.610379518, 0.095879151, -0.663118727, 0.50821984, -0.741815419, 2.38531026, 0.354750355, 0.658437634],
[-0.337849025, -0.535265918, 0.803160459, 0.275911465, 0.981343049, -0.748451144, -0.092431408, -0.326477104, -0.381243917, -0.575343824, -0.63351617, -0.380961411, -1.720616197, -0.85605361, -0.580950374, 0.373293116, 0.905490886, 0.135705555, 1.107780656, -0.545183144, 0.475561701, 0.016687596, -0.172178219, 0.585186686, -0.40480014, -3.997318149, 0.711029765, -0.470884061, 0.354386296],
[-0.368173217, 0.209192446, 0.266317555, -0.100656799, -0.336791718, -0.060827204, -0.199021599, -0.765882671, -0.071476548, -0.4402703, -0.3548684, 3.468121376, 5.853726714, -0.465135408, 0.074434692, 7.085199705, -0.399050575, -0.334999773, -0.623071147, -0.406230833, 0.939058116, -0.269533885, 0.117950503, 0.1975473, -0.365407931, -0.056856473, 0.001983212, 0.081609959, -0.603299855]])

